'*******************************************************************************
' Frequenzmessung fr ATmega32
'
' Autor: Dipl.-Ing. M.Sc. Christian Nding
' v1.0
' 08.12.2011
'
' Zielhardware: ATmega32 mit 16MHz (AVR-NET-IO von Pollin)
'*******************************************************************************

$regfile = "m32def.dat"                                     ' specify the used micro
$crystal = 16000000                                         ' used crystal frequency
$baud = 38400                                               ' use baud rate
$hwstack = 32                                               ' default use 32 for the hardware stack
$swstack = 10                                               ' default use 10 for the SW stack
$framesize = 40                                             ' default use 40 for the frame space


Config Portd.2 = Input

' LCD an EXT
'Config Portd.2 = Output
'Reset Portd.2

' LCD an EXT
'Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portb.0 , Rs = Portd.3
'Config Lcd = 16 * 2

' LCD an SUB-D
Config Lcdpin = Pin , Db4 = Portc.0 , Db5 = Portc.1 , Db6 = Portc.2 , Db7 = Portc.3 , E = Portc.6 , Rs = Portc.4
Config Lcd = 16 * 2

' Timer 1 zhlt mit Prescaler=8, sodass bei 16MHz ein Zhlertakt 0.5s entspricht
Config Timer1 = Timer , Prescale = 8                        'Konfiguriere Timer1 (1 , 8, 64, 256 or 1024)
Enable Timer1

Config Int0 = Falling
On Int0 Int0int
Enable Int0

Enable Interrupts



'#################################################################################
' Variablen ab hier definieren
Dim Sendmessage(5) As Byte
Dim Myword As Word
Dim Frequencycounter As Word
Dim Frequency As Single


'#################################################################################
' Nun Programm starten
Timer1 = 0


Display On : Cls
Cursor Off



'#################################################################################
' Hauptprogrammschleife
Do
   Waitms 250

   ' Frequenz fr LCD berechnen
   Frequency = Frequencycounter / 2000
   Frequency = 1000 / Frequency
   Upperline
   Lcd "Netzfrequenz:   "
   Lowerline
   Lcd Fusing(frequency , "#.###") ; " Hz       "

   ' Timer-Ticks per RS232 versenden
   Sendmessage(1) = 65
   Sendmessage(2) = Frequencycounter
   Myword = Frequencycounter
   Shift Myword , Right , 8
   Sendmessage(3) = Myword
   Sendmessage(4) = 69
   Sendmessage(5) = 13
   Printbin Sendmessage(1)
Loop

Int0int:
   Frequencycounter = Timer1
   Timer1 = 0
Return